<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>tubafashe-api documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">tubafashe-api documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content injectable">
                   <div class="content-data">







<ol class="breadcrumb">
  <li>Injectables</li>
  <li>KpayService</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>src/payment/service/kpay.service.ts</code>
        </p>




            <section>
    <h3 id="index">Index</h3>
    <table class="table table-sm table-bordered index-table">
        <tbody>
                <tr>
                    <td class="col-md-4">
                        <h6><b>Properties</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                    <span class="modifier">Private</span>
                                    <span class="modifier">Readonly</span>
                                <a href="#kpayApiGot">kpayApiGot</a>
                            </li>
                        </ul>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <h6><b>Methods</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                    <span class="modifier">Private</span>
                                    <span class="modifier">Async</span>
                                <a href="#apiCall">apiCall</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                    <span class="modifier">Async</span>
                                <a href="#checkDonator">checkDonator</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                    <span class="modifier">Async</span>
                                <a href="#convertAmount">convertAmount</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#refidGenerator">refidGenerator</a>
                            </li>
                            <li>
                                    <span class="modifier">Public</span>
                                    <span class="modifier">Async</span>
                                <a href="#sendPayment">sendPayment</a>
                            </li>
                        </ul>
                    </td>
                </tr>





        </tbody>
    </table>
</section>

            <section>
    <h3 id="constructor">Constructor</h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
<code>constructor(configBucket: <a href="../classes/ConfigBucket.html">ConfigBucket</a>, donatorService: <a href="../injectables/DonatorService.html">DonatorService</a>, currencyRateService: <a href="../injectables/CurrencyRateService.html">CurrencyRateService</a>, appLogger: <a href="../injectables/AppLogger.html">AppLogger</a>)</code>
                    </td>
                </tr>
                        <tr>
                            <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="17" class="link-to-prism">src/payment/service/kpay.service.ts:17</a></div>
                            </td>
                        </tr>

                <tr>
                    <td class="col-md-4">
                            <div>
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>configBucket</td>

                                                        <td>
                                                                        <code><a href="../classes/ConfigBucket.html" target="_self" >ConfigBucket</a></code>
                                                        </td>

                                                    <td>
                                                            No
                                                    </td>

                                                </tr>
                                                <tr>
                                                        <td>donatorService</td>

                                                        <td>
                                                                        <code><a href="../injectables/DonatorService.html" target="_self" >DonatorService</a></code>
                                                        </td>

                                                    <td>
                                                            No
                                                    </td>

                                                </tr>
                                                <tr>
                                                        <td>currencyRateService</td>

                                                        <td>
                                                                        <code><a href="../injectables/CurrencyRateService.html" target="_self" >CurrencyRateService</a></code>
                                                        </td>

                                                    <td>
                                                            No
                                                    </td>

                                                </tr>
                                                <tr>
                                                        <td>appLogger</td>

                                                        <td>
                                                                        <code><a href="../injectables/AppLogger.html" target="_self" >AppLogger</a></code>
                                                        </td>

                                                    <td>
                                                            No
                                                    </td>

                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>

            <section>

    <h3 id="methods">
        Methods
    </h3>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="apiCall"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Private</span>
                            <span class="modifier">Async</span>
                            apiCall
                        </b>
                        <a href="#apiCall"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>apiCall(kpayPaymentRequestDto: <a href="../classes/KpayPaymentRequestDto.html">PaymentRequestDto</a>, donator: <a href="../classes/Donator.html">Donator</a>)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="45"
                            class="link-to-prism">src/payment/service/kpay.service.ts:45</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>kpayPaymentRequestDto</td>
                                    <td>
                                                <code><a href="../classes/KpayPaymentRequestDto.html" target="_self" >PaymentRequestDto</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                                <tr>
                                    <td>donator</td>
                                    <td>
                                                <code><a href="../classes/Donator.html" target="_self" >Donator</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>    <code>Promise&lt;KpayPaymentResponseDto&gt;</code>

                    </div>
                    <div class="io-description">

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="checkDonator"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Private</span>
                            <span class="modifier">Async</span>
                            checkDonator
                        </b>
                        <a href="#checkDonator"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>checkDonator(donatorId: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="73"
                            class="link-to-prism">src/payment/service/kpay.service.ts:73</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>donatorId</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="../classes/Donator.html" target="_self" >Promise&lt;Donator&gt;</a></code>

                    </div>
                    <div class="io-description">

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="convertAmount"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Private</span>
                            <span class="modifier">Async</span>
                            convertAmount
                        </b>
                        <a href="#convertAmount"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>convertAmount(amount: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/number" target="_blank">number</a>)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="77"
                            class="link-to-prism">src/payment/service/kpay.service.ts:77</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>amount</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/number" target="_blank" >number</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>    <code>Promise&lt;number&gt;</code>

                    </div>
                    <div class="io-description">

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="refidGenerator"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Private</span>
                            refidGenerator
                        </b>
                        <a href="#refidGenerator"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>refidGenerator(length: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/number" target="_blank">number</a>)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="83"
                            class="link-to-prism">src/payment/service/kpay.service.ts:83</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>length</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/number" target="_blank" >number</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>

                    </div>
                    <div class="io-description">

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="sendPayment"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Public</span>
                            <span class="modifier">Async</span>
                            sendPayment
                        </b>
                        <a href="#sendPayment"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>sendPayment(kpayPaymentRequestDto: <a href="../classes/KpayPaymentRequestDto.html">PaymentRequestDto</a>)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="32"
                            class="link-to-prism">src/payment/service/kpay.service.ts:32</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>kpayPaymentRequestDto</td>
                                    <td>
                                                <code><a href="../classes/KpayPaymentRequestDto.html" target="_self" >PaymentRequestDto</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>    <code>Promise&lt;KpayPaymentResponseDto&gt;</code>

                    </div>
                    <div class="io-description">

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
</section>
            <section>

        <h3 id="inputs">
            Properties
        </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="kpayApiGot"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                                <span class="modifier">Readonly</span>
                            kpayApiGot</b>
                            <a href="#kpayApiGot"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code>Got</code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="17" class="link-to-prism">src/payment/service/kpay.service.ts:17</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
</section>

    </div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { Injectable } from &#x27;@nestjs/common&#x27;;
import { PaymentRequestDto } from &#x27;../dto/kpay-payment-request.dto&#x27;;
import got, { Got } from &#x27;got&#x27;;
import { ConfigBucket } from &#x27;../../common/config-bucket&#x27;;
import { AppLogger } from &#x27;../../common/app-logger&#x27;;
import { KpayPaymentResponseDto } from &#x27;../dto/kpay-payment-response.dto&#x27;;
import { DonatorService } from &#x27;../../donator/service/donator.service&#x27;;
import { Donator } from &#x27;../../donator/entity/donator.entity&#x27;;
import { NotFoundException } from &#x27;../../common/exception/notfound.exception&#x27;;
import { KpayException } from &#x27;../../common/exception/kpay.exception&#x27;;
import { KpayPayloadDto } from &#x27;../dto/kpay-payload.dto&#x27;;
import { CurrencyRateService } from &#x27;./currency-rate.service&#x27;;
import { CurrencyRateResponseDto } from &#x27;../dto/currency-rate-response.dto&#x27;;

@Injectable()
export class KpayService {
  private readonly kpayApiGot: Got;

  constructor(private readonly configBucket: ConfigBucket,
              private readonly donatorService: DonatorService,
              private readonly currencyRateService: CurrencyRateService,
              private appLogger: AppLogger) {
    this.appLogger.setContext(&#x27;KpayService&#x27;);
    this.kpayApiGot &#x3D; got.extend({
      prefixUrl: this.configBucket.KPAY_URL_PAYMENT,
      headers: {
        &#x27;Content-Type&#x27;: &#x27;application/json&#x27;,
      },
    });
  }

  public async sendPayment(kpayPaymentRequestDto: PaymentRequestDto): Promise&lt;KpayPaymentResponseDto&gt; {
    this.appLogger.log(&#x27;sendPayment&#x27;);
    if (kpayPaymentRequestDto.donatorId &#x3D;&#x3D;&#x3D; undefined) {
      throw new Error(&#x27;Donator ID missing&#x27;);
    }
    const donator: Donator &#x3D; await this.donatorService.findByPk(kpayPaymentRequestDto.donatorId);
    if (!donator) {
      throw new NotFoundException(&#x27;Donator with ID: &#x27; + kpayPaymentRequestDto.donatorId + &#x27; not found!&#x27;);
    }

    return await this.apiCall(kpayPaymentRequestDto, donator);
  }

  private async apiCall(kpayPaymentRequestDto: PaymentRequestDto, donator: Donator): Promise&lt;KpayPaymentResponseDto&gt; {
    const kpayPayloadDto &#x3D; new KpayPayloadDto();
    kpayPayloadDto.refid &#x3D; this.refidGenerator(5);
    kpayPayloadDto.details &#x3D; &#x27;Covid 19 - Donate&#x27;;
    kpayPayloadDto.retailerid &#x3D; this.configBucket.KPAY_RETAILERID;
    kpayPayloadDto.returl &#x3D; this.configBucket.KPAY_RETURL;
    kpayPayloadDto.pmethod &#x3D; kpayPaymentRequestDto.pmethod;
    kpayPayloadDto.msisdn &#x3D; kpayPaymentRequestDto.phoneNumber;
    kpayPayloadDto.cname &#x3D; donator.firstName + &#x27; &#x27; + donator.lastName;
    kpayPayloadDto.amount &#x3D; await this.convertAmount(kpayPaymentRequestDto.amount);
    kpayPayloadDto.bankid &#x3D; this.configBucket.KPAY_BANKID;
    kpayPayloadDto.redirecturl &#x3D; this.configBucket.KPAY_REDIRECTURL;
    // tslint:disable-next-line:no-console
    console.log(kpayPayloadDto);
    const kpayPaymentResponseDto: KpayPaymentResponseDto &#x3D; await this.kpayApiGot.post(&#x27;&#x27;,
      {
        json: kpayPayloadDto,
        username: this.configBucket.KPAY_LOGIN,
        password: this.configBucket.KPAY_PWD,
      }).json&lt;KpayPaymentResponseDto&gt;();

    if (kpayPaymentResponseDto.success &#x3D;&#x3D;&#x3D; 0) {
      throw new KpayException(kpayPaymentResponseDto.reply);
    }

    return new KpayPaymentResponseDto();
  }

  private async checkDonator(donatorId: string): Promise&lt;Donator&gt; {
    return await this.donatorService.findByPk(donatorId);
  }

  private async convertAmount(amount: number): Promise&lt;number&gt; {
    const currencyRate: CurrencyRateResponseDto &#x3D; await this.currencyRateService.getCurrencyRate();
    const converted: number &#x3D; +currencyRate.rates.RWF * amount;
    return Number(converted.toFixed());
  }

  private refidGenerator(length: number): string {
    const millis &#x3D; Date.now();
    let result &#x3D; &#x27;&#x27;;
    const characters &#x3D; &#x27;ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789&#x27;;
    const charactersLength &#x3D; characters.length;
    for (let i &#x3D; 0; i &lt; length; i++) {
      result +&#x3D; characters.charAt(Math.floor(Math.random() * charactersLength));
    }
    return result + millis;
  }
}
</code></pre>
    </div>

</div>












                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'injectable';
            var COMPODOC_CURRENT_PAGE_URL = 'KpayService.html';
            var MAX_SEARCH_RESULTS = 15;
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
